'>Bambino-09
'>Robot R-Bambino
Sertxd("B13",cr)		'report program number

#PicAxe 20M2
#no_data

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input
'Bambino-02a	'Test Eye light values
'Bambino-02b	'Test Whisker light values and put in EEPROM
'Bambino-03	'Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-04	'Set servos to mid position	
'Bambino-05	'Calibrate servo mid positions and put in EEPROM.
'Bambino-06	'Introduce _iStand:- initialise with feet in mid position
'Bambino-07	'Set rollR
'Bambino-08	'Set rollL
'Bambino-09	'Check rollR, rollL
'Bambino-10	'Introduction of _Stand
'Bambino-11	'Investigate effect of rollspeed;	watch roll for all three speeds
'Bambino-12	'Investigate effect of rollspeed;	watch Roll and Stand for all three speeds
'Bambino-13	'Check paceFL paceFR;	Investigate effect of pacespeed

'Check paceFL paceFR
'-------------------
'edit paceFL and paceFR and reload program 
'	until left and right pace is equal

'Investigate effect of pacespeed
'-------------------------------
'edit pacespeed to see how Woodly performs


'modified
'--------
'init
'start
'_StandL:
'_StandR
'_rollL
'_rollR

'New
'---
'paceat
'paceFR	'Right foot forward
'paceFL	'Left  foot forward
'pacespeed
'_RF
'_LF


symbol servopace    =c.0 'left connector
symbol servoroll    =c.4 'right connector
symbol VoiceLed_    =c.5
symbol eyeLedL_     =c.2 'low =>LED on 
symbol eyeLedR_     =b.1 'low =>LED on
symbol whiskerLedL_ =c.3    'low =>whisker LED on
symbol whiskerLedR_ =b.3    'low =>whisker LED on
symbol iIRin        =c.6
symbol oIRout       =b.2

symbol rollC	=150	'100 is roll to the left
symbol paceC	=150	'100 is left foot back

symbol spulse 	=b2
'symbol i2 		=b3
symbol rollat 	=b4
symbol paceat 	=b5

symbol rollR      =rollC+15
symbol rollL      =rollC-15
symbol rollspeed  =b6   '4 is too fast, 0 won't move
symbol paceFR	=paceC-20	'Right foot forward
symbol paceFL	=paceC+20	'Left  foot forward
symbol paceFRmax	=100	'Right foot forward
symbol paceFLmax	=190	'Left  foot forward
symbol sframe     =20	'time between servo pulses
symbol pacespeed  =b7    '6 is about max for servos to keep up



initialise:
	low eyeLedR_		'make output
	high eyeLedL_	'make output
	gosub _iStand
	pacespeed =6  

start:
	toggle eyeLedR_	'alter eyeR so we know program is running
	toggle eyeLedL_	'alter eyeR so we know program is running
	gosub _RF
	pause 500
	gosub _LF
	pause 500
	goto start




_RF:
	for spulse=paceat to paceFR step -pacespeed
	  paceat =spulse
	  pulsout servopace,paceat	'pulse servo
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_LF:
	for spulse=paceat to paceFL step pacespeed
	  paceat =spulse
	  pulsout servopace,paceat	'pulse servo
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

Stand:	'stand with both feet flat
	if rollat<rollC then _StandR
_StandL:
	for spulse=rollat to rollC step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_StandR:
	for spulse=rollat to rollC step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_rollL:
	for spulse=rollat to rollL step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
	 
_rollR:
	for spulse=rollat to rollR step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_iStand:
'initialise with feet in mid position
	for spulse=0 to 10
	  pulsout servopace,paceC	'pulse servo paceC
	  pulsout servoroll,rollC	'pulse servo rollC
	  pause 70				'pause 70ms - do it slowly
	 next spulse
	rollat =rollC
	paceat =paceC 
	return 