'>Bambino-02
'>Robot R-Bambino
Sertxd("B02",cr)		'report program number

#PicAxe 20M2
#no_data

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input

'Test InfraRed input
'-------------------
'	receive IR code and send it to the PC;
'	open the Terminal window [F8] to see the codes;
'		set the baud to 4800;
'	if you are not using the PicAxe controller TVR010
'	then you will need to write down which keys give which codes;


symbol VoiceLed_     =c.5
symbol eyeLedL_      =c.2    'low =>LED on 
symbol eyeLedR_      =b.1    'low =>LED on
symbol whiskerLedL_  =c.3    'low =>whisker LED on
symbol whiskerLedR_  =b.3    'low =>whisker LED on
symbol iIRin         =c.6

'=================================================================
'TVR010 PicAxe IR-controller
'---------------------------
'Before use, the transmitter must be programmed with the Sony transmit code.
'1. Insert 2 AAA size batteries, preferably alkaline.
'2. Press S and B at the same time. S is in the centre of the arrows. 
'	The top left red LED should light.
'3. Press 0. The LED should flash.
'4. Press 1. The LED should flash.
'5. Press 3. The LED should go out.
'6. Press the red power button (top right).
'-------------------------------------------
'IRin cmnds PicAxe controller
'DO NOT PRESS OTHER KEYS 
'ie [A] [B] [C] [D] [E] [F] [G] 
'They change the Mode and [B] has to be pressed to change back.
'[square] [triangle [()] [L] [X] [backwards F]  have no effect

Symbol KEY_POWER  = 21	

Symbol KEY_UP     = 16	
Symbol KEY_DOWN   = 17	
Symbol KEY_RIGHT  = 18	
Symbol KEY_LEFT   = 19	

Symbol KEY_BAR    = 96
Symbol KEY_TENT   = 54
Symbol KEY_VERT_CROSS = 37
Symbol KEY_VCROSS = 37		'synonym for easier coding
Symbol KEY_DIAG_CROSS = 20
Symbol KEY_XCROSS = 20		'synonym for easier coding
symbol IRkey1     =  0
symbol IRkey2     =  1
symbol IRkey3     =  2
symbol IRkey4     =  3
symbol IRkey5     =  4
symbol IRkey6     =  5
symbol IRkey7     =  6
symbol IRkey8     =  7
symbol IRkey9     =  8
Symbol KEY_MINUS  = 98
Symbol KEY_0      =  9	
Symbol KEY_PLUS   = 11
'=================================================================

initialise:
	low eyeLedR_				'make output
	low eyeLedL_				'make output

start:
	let b0 = b0 + 1               'increment b0
	sound VoiceLed_,(b0,2)    	'make a sound
	toggle eyeLedR_			'alter eyeR
	toggle eyeLedL_			'alter eyeL
	irin [100,start],iIRin,b1	'irin with timeout
'	irin iIRin,b1			'irin with no timeout
	sertxd (#b1," ",cr)   		'send value back to PC
	goto start                    'loop back to start



